Related:
LeetCode 380 - Insert Delete GetRandom O(1)
LeetCode 381 - Insert Delete GetRandom O(1) - Duplicates allowed
http://www.cnblogs.com/grandyang/p/5740864.html
X. Follow up
https://discuss.leetcode.com/topic/53216/java-solution-using-a-hashmap-and-an-arraylist-along-with-a-follow-up-131-ms/4
https://reeestart.wordpress.com/2016/06/10/google-design-a-data-structure-to-support-add-get-set-delete-getrandom-in-o1-time/
https://reeestart.wordpress.com/2016/06/14/google-design-a-data-structure-to-support-insert-delete-medium-and-mode/
https://github.com/zxqiu/leetcode-lintcode/blob/master/system%20design/Load_Balancer.java
Implement a load balancer for web servers. It provide the following functionality:
Add a new server to the cluster => add(server_id).
Remove a bad server from the cluster => remove(server_id).
Pick a server in the cluster randomly with equal probability => pick().
Example
At beginning, the cluster is empty => {}.
add(1)
add(2)
add(3)
pick()
>> 1 // the return value is random, it can be either 1, 2, or 3.
pick()
>> 2
pick()
>> 1
pick()
>> 3
remove(1)
pick()
>> 2
pick()
>> 3
pick()
>> 3
解:
Circular Linked List
这道题基本思路是使用一个ArrayList保存server表,然后随机返回其中一个下标对应的server就可以。
但是这样做,add时间复杂度O(1),remove是O(n),pick是O(1),并不是很理想。
理想情况下add,remove,pick都应该是O(1)。
分析以下需要解决的问题:
1,如何O(1)的根据server_id删除某一个server。
2,如何保证pick概率平均。
add很简单,大多数数据结构都可以O(1)操作,所以不需要考虑。
为了解决上面的问题,需要的信息有:
1,为了保证O(1)删除,那么首先一定不能使用ArrayList或者数组之类的结构,因为查找server_id必须要遍历。就算根据server_id进行了排序,最快也得O(log(n))。
可以做到O(1)删除的数据结构最容易想到的是HashMap和HashSet。
2,为了保证pick概率平均,最简单的方案是round robin。用一个pointer轮流指向并返回列表中的server。到达最后一个的时后就返回列表头。
由于不可以用数组之类依赖下标的结构,那么还能做到从表尾直接返回表头的结构就是circular linked list。
综上,把server_id作为HashMap的key,circular linked list的节点作为HashMap的value,并用一个指针轮流指向这个list,就可以满足条件。
为了简单的在circular linked list中做删除,使用双向指针。
*/
public class LoadBalancer {
private class Node {
int id;
Node prev, next;
Node(int id) {
this.id = id;
prev = this;
next = this;
}
}
Map<Integer, Node> servers;
Node server;
public LoadBalancer() {
servers = new HashMap<>();
server = null;
}
// @param server_id add a new server to the cluster
// @return void
public void add(int server_id) {
if (servers.containsKey(server_id)) {
return;
}
Node newServer = new Node(server_id);
if (server == null) {
// initiate first server
server = newServer;
}
newServer.next = server.next;
newServer.prev = server;
server.next.prev = newServer;
server.next = newServer;
servers.put(server_id, newServer);
}
// @param server_id server_id remove a bad server from the cluster
// @return void
public void remove(int server_id) {
if (!servers.containsKey(server_id)) {
return;
}
Node node = servers.get(server_id);
if (node == server) {
// current server will be removed. move to next server.
server = server.next;
}
node.prev.next = node.next;
node.next.prev = node.prev;
servers.remove(server_id);
if (servers.isEmpty()) {
// if last server is removed, clear pointer
server = null;
}
}
// @return pick a server in the cluster randomly with equal probability
public int pick() {
server = server.next;
return server.id;
}
http://massivealgorithms.blogspot.com/2016/08/leetcode-381-insert-delete-getrandom-o1.html
1. 嘴贱问如果有重复元素要不不要根据加⼊入次数作为weight返回,⾯面试官看
起来没有想过这个问题,还有时间,于是讨论了了思路路,该⽤用了了list存所有
index,写了了⼀一下代码,感觉应该没有问题
2. 变形:给⼀一些数字,Implement randomPop()来randomly pop中间的⼀一
个数字
1.if
(map.get(val).isEmpt
y()) map.remove(val);
2. Swapee != val
3. 381 with duplicates (code)
LeetCode 380 - Insert Delete GetRandom O(1)
LeetCode 381 - Insert Delete GetRandom O(1) - Duplicates allowed
http://www.cnblogs.com/grandyang/p/5740864.html
Design a data structure that supports all following operations in average O(1) time.
insert(val)
: Inserts an item val to the set if not already present.remove(val)
: Removes an item val from the set if present.getRandom
: Returns a random element from current set of elements. Each element must have the same probability of being returned.
Example:
// Init an empty set. RandomizedSet randomSet = new RandomizedSet(); // Inserts 1 to the set. Returns true as 1 was inserted successfully. randomSet.insert(1); // Returns false as 2 does not exist in the set. randomSet.remove(2); // Inserts 2 to the set, returns true. Set now contains [1,2]. randomSet.insert(2); // getRandom should return either 1 or 2 randomly. randomSet.getRandom(); // Removes 1 from the set, returns true. Set now contains [2]. randomSet.remove(1); // 2 was already in the set, so return false. randomSet.insert(2); // Since 1 is the only number in the set, getRandom always return 1. randomSet.getRandom();
此题的正确解法是利用到了一个一维数组和一个哈希表,其中数组用来保存数字,哈希表用来建立每个数字和其在数组中的位置之间的映射,对于插入操作,我们先看这个数字是否已经在哈希表中存在,如果存在的话直接返回false,不存在的话,我们将其插入到数组的末尾,然后建立数字和其位置的映射。删除操作是比较tricky的,我们还是要先判断其是否在哈希表里,如果没有,直接返回false。由于哈希表的删除是常数时间的,而数组并不是,为了使数组删除也能常数级,我们实际上将要删除的数字和数组的最后一个数字调换个位置,然后修改对应的哈希表中的值,这样我们只需要删除数组的最后一个元素即可,保证了常数时间内的删除。而返回随机数对于数组来说就很简单了,我们只要随机生成一个位置,返回该位置上的数字即可
ArrayList 的本质是 Array,
so list.remove(list.size() - 1) -> time complexity is only O(1)
so list.remove(list.size() - 1) -> time complexity is only O(1)
public class RandomizedSet {
private HashMap<Integer, Integer> map; // value -> index
private ArrayList<Integer> list; // value
private Random rand;
/** Initialize your data structure here. */
public RandomizedSet() {
map = new HashMap<Integer, Integer>();
list = new ArrayList<Integer>();
rand = new Random();
}
/** Inserts a value to the set. Returns true if the set did not already contain the specified element. */
public boolean insert(int val) {
if (map.containsKey(val)) {
return false;
}
else {
map.put(val, list.size());
list.add(val);
return true;
}
}
/** Removes a value from the set. Returns true if the set contained the specified element. */
public boolean remove(int val) {
if (!map.containsKey(val)) {
return false;
}
else {
int index = map.remove(val);
int last = list.remove(list.size() - 1);
if (last != val) {
list.set(index, last);
map.put(last, index);
}
return true;
}
}
/** Get a random element from the set. */
public int getRandom() {
int index = rand.nextInt(list.size());
return list.get(index);
}
}
X.
private HashMap<Integer, Integer> keyMap = null;
private HashMap<Integer, Integer> valueMap = null;
int count;
/** Initialize your data structure here. */
public RandomizedSet() {
keyMap = new HashMap<Integer, Integer>();
valueMap = new HashMap<Integer, Integer>();
}
/** Inserts a value to the set. Returns true if the set did not already contain the specified element. */
public boolean insert(int val) {
if(keyMap.containsKey(val)) {
return false;
} else {
keyMap.put(val, count);
valueMap.put(count, val);
count = keyMap.size();
return true;
}
}
/** Removes a value from the set. Returns true if the set contained the specified element. */
public boolean remove(int val) {
if(!keyMap.containsKey(val)) {
return false;
} else {
int valueKey = keyMap.get(val);
keyMap.remove(val);
if(valueKey != valueMap.size() - 1) {
valueMap.put(valueKey, valueMap.get(valueMap.size() - 1));
keyMap.put(valueMap.get(valueMap.size() - 1), valueKey);
valueMap.remove(valueMap.size() - 1);
} else {
valueMap.remove(valueKey);
}
count = keyMap.size();
return true;
}
}
/** Get a random element from the set. */
public int getRandom() {
Random random = new Random();
int n = random.nextInt(keyMap.size());
return valueMap.get(n);
}
We can use two hashmaps to solve this problem. One uses value as keys and the other uses index as the keys.
https://discuss.leetcode.com/topic/53216/java-solution-using-a-hashmap-and-an-arraylist-along-with-a-follow-up-131-ms/4
How do you modify your code to allow duplicated number?
The follow-up: allowing duplications.
For example, after insert(1), insert(1), insert(2), getRandom() should have 2/3 chance return 1 and 1/3 chance return 2.
Then, remove(1), 1 and 2 should have an equal chance of being selected by getRandom().
For example, after insert(1), insert(1), insert(2), getRandom() should have 2/3 chance return 1 and 1/3 chance return 2.
Then, remove(1), 1 and 2 should have an equal chance of being selected by getRandom().
The idea is to add a set to the hashMap to remember all the locations of a duplicated number.
2 Hash Table + 1 List
valueMap<Integer, Integer> stores key-value pair
indexMap<Integer, Integer> stores key-index pair, where index is the index in the List. This hash table is to support delete operation in O(1) time.
List is for getRandom() method.
There is another tricky place in Delete operation. Instead of compare the trade off between ArrayList and LinkedList, maintain a variable N to store the number of keys in this data structure, whenever a delete operation is executed, just swap the keys with the last one and decrement N by one. In this way, delete operation is guaranteed in Constant time.
class
RandomizedHashTable {
Map<Integer, Integer> valueMap =
new
HashMap<>();
Map<Integer, Integer> indexMap =
new
HashMap<>();
List<Integer> keys =
new
ArrayList<>();
int
N =
0
;
/* Insert a key-value */
public
void
insert(
int
key,
int
val) {
if
(valueMap.containsKey(key)) {
return
;
}
valueMap.put(key, val);
keys.add(key);
indexMap.put(key, keys.size() -
1
);
N++;
}
/* Get the value */
public
int
get(
int
key) {
if
(!valueMap.containsKey(key)) {
throw
new
IllegalArgumentException();
}
return
valueMap.get(key);
}
/* Update the value */
public
void
set(
int
key,
int
val) {
if
(!valueMap.containsKey(key)) {
return
;
}
valueMap.put(key, val);
}
/* Get a random value */
public
int
getRandom() {
int
index =
new
Random().randInt(keys.size());
return
valueMap.get(keys.get(index));
}
/* Delete a key-value */
public
void
delete(
int
key) {
if
(!valueMap.containsKey(key)) {
return
;
}
valueMap.remove(key); // ALSO
indexMap.remove(key);
int
index = indexMap.get(key);
int
last = keys.get(N -
1
);
indexMap.put(last, index);
swap(keys, index, N -
1
);
N--;
}
private
void
swap(List<Integer> keys,
int
l,
int
r) {
int
tmp = keys.get(l);
keys.set(l, keys.get(r);
keys.set(r, tmp);
}
}
https://reeestart.wordpress.com/2016/06/14/google-design-a-data-structure-to-support-insert-delete-medium-and-mode/
Design a data structure to support insert(), delete(), medium() and mode()
mode() 是众数,出现最多的那个。
BST + Heap
class TNode {
int val;
int freq;
int leftSize;
}
int val;
int freq;
int leftSize;
}
insert() O(logn)
delete() O(logn)
medium() O(logn)
mode() O(1)
delete() O(logn)
medium() O(logn)
mode() O(1)
Use a PriorityQueue to on TNode.freq to get mode number.
Implement a load balancer for web servers. It provide the following functionality:
Add a new server to the cluster => add(server_id).
Remove a bad server from the cluster => remove(server_id).
Pick a server in the cluster randomly with equal probability => pick().
Example
At beginning, the cluster is empty => {}.
add(1)
add(2)
add(3)
pick()
>> 1 // the return value is random, it can be either 1, 2, or 3.
pick()
>> 2
pick()
>> 1
pick()
>> 3
remove(1)
pick()
>> 2
pick()
>> 3
pick()
>> 3
解:
Circular Linked List
这道题基本思路是使用一个ArrayList保存server表,然后随机返回其中一个下标对应的server就可以。
但是这样做,add时间复杂度O(1),remove是O(n),pick是O(1),并不是很理想。
理想情况下add,remove,pick都应该是O(1)。
分析以下需要解决的问题:
1,如何O(1)的根据server_id删除某一个server。
2,如何保证pick概率平均。
add很简单,大多数数据结构都可以O(1)操作,所以不需要考虑。
为了解决上面的问题,需要的信息有:
1,为了保证O(1)删除,那么首先一定不能使用ArrayList或者数组之类的结构,因为查找server_id必须要遍历。就算根据server_id进行了排序,最快也得O(log(n))。
可以做到O(1)删除的数据结构最容易想到的是HashMap和HashSet。
2,为了保证pick概率平均,最简单的方案是round robin。用一个pointer轮流指向并返回列表中的server。到达最后一个的时后就返回列表头。
由于不可以用数组之类依赖下标的结构,那么还能做到从表尾直接返回表头的结构就是circular linked list。
综上,把server_id作为HashMap的key,circular linked list的节点作为HashMap的value,并用一个指针轮流指向这个list,就可以满足条件。
为了简单的在circular linked list中做删除,使用双向指针。
*/
public class LoadBalancer {
private class Node {
int id;
Node prev, next;
Node(int id) {
this.id = id;
prev = this;
next = this;
}
}
Map<Integer, Node> servers;
Node server;
public LoadBalancer() {
servers = new HashMap<>();
server = null;
}
// @param server_id add a new server to the cluster
// @return void
public void add(int server_id) {
if (servers.containsKey(server_id)) {
return;
}
Node newServer = new Node(server_id);
if (server == null) {
// initiate first server
server = newServer;
}
newServer.next = server.next;
newServer.prev = server;
server.next.prev = newServer;
server.next = newServer;
servers.put(server_id, newServer);
}
// @param server_id server_id remove a bad server from the cluster
// @return void
public void remove(int server_id) {
if (!servers.containsKey(server_id)) {
return;
}
Node node = servers.get(server_id);
if (node == server) {
// current server will be removed. move to next server.
server = server.next;
}
node.prev.next = node.next;
node.next.prev = node.prev;
servers.remove(server_id);
if (servers.isEmpty()) {
// if last server is removed, clear pointer
server = null;
}
}
// @return pick a server in the cluster randomly with equal probability
public int pick() {
server = server.next;
return server.id;
}
http://massivealgorithms.blogspot.com/2016/08/leetcode-381-insert-delete-getrandom-o1.html
1. 嘴贱问如果有重复元素要不不要根据加⼊入次数作为weight返回,⾯面试官看
起来没有想过这个问题,还有时间,于是讨论了了思路路,该⽤用了了list存所有
index,写了了⼀一下代码,感觉应该没有问题
2. 变形:给⼀一些数字,Implement randomPop()来randomly pop中间的⼀一
个数字
1.if
(map.get(val).isEmpt
y()) map.remove(val);
2. Swapee != val
3. 381 with duplicates (code)